//#ifndef     MBED_PCA9955
//#define     MBED_PCA9955

#include    "mbed.h"
#include    "PCA995x.h"

class PCA9955 : public PCA995x
{
public:

     enum command_reg {
        RESERVED1   = 0x3F,
        RESERVED2,
        RESERVED3,
        PWMALL,
        IREFALL,
        EFLAG0,
        EFLAG1,
    };

    PCA9955( PinName I2C_sda, PinName I2C_scl, char I2C_address ) : PCA995x( I2C_sda, I2C_scl, I2C_address, PCA995x::PCA9955 ) {
    }

    PCA9955& operator= ( int c ) {
        PCA995x::operator= ( c );
        return *this;
    }

    unsigned short fault_test( void ) {
        char    mode2_reg;

#define     FAULTTEST   0x40

        mode2_reg   = read( MODE2 );
        mode2_reg   = 0;
        write( PCA995x::MODE2, (char)(mode2_reg | FAULTTEST) );

        while ( read( MODE2 ) & FAULTTEST )
            ;

        return( ((unsigned short)(read( EFLAG1 )) << 8) | read( EFLAG0 ) );
    }

private:
}
;

//#endif  //  MBED_PCA9955
